//Analog volt read pin
const int voltPin = 0;
// built in LED
const int ledPin =  LED_BUILTIN;// the number of the LED pin
const int mosfet = 6; //output from the LVD

// 500 millis delay in the loop. So let's adjust the timing of things
const int ChangeOverTime = 10; // figure out the multiple for the delay at bottom 
int timetracker = 0; //keeping track of the number of half seconds

String lvdstatus = "OFF"; //keep track of the status of the system
int ledState = LOW; // ledState used to set the LED

// Set cut-in and cut-out (adjust for 12v)
const float voltage_low = 10.9;
const float voltage_high = 11.5;

//Variables for voltage divider
float denominator;
int resistor1 = 47;
int resistor2 = 10;


void setup() {

  // initialize digital pin LED_BUILTIN as an output.
  pinMode(LED_BUILTIN, OUTPUT);
  pinMode(mosfet, OUTPUT);
  digitalWrite(mosfet, LOW);

  Serial.begin(9600);
  //Convert resistor values to division value
  //  Equation is previously mentions voltage divider equation
  //  R2 / (R1 + R2)
  denominator = (float)resistor2 / (resistor1 + resistor2);


}

void loop() {

 float voltage;
  //Obtain RAW voltage data
  voltage = analogRead(voltPin);
  //Convert to actual voltage (0 - 5 Vdc)
  voltage = (voltage / 1024) * 5.0;
  //Convert to voltage before divider
  //  Divide by divider = multiply
  //  Divide by 1/5 = multiply by 5
  voltage = voltage / denominator;
  //Output to serial
  Serial.print("Volts: ");
  Serial.println(voltage);
  Serial.print("timetracker: ");
  Serial.println(timetracker);
  Serial.print("Status: ");
  Serial.println(lvdstatus);
  Serial.println();



// ---------- MANAGE THE OUTPUT ------------


if(lvdstatus == "ON" and voltage < voltage_low){
    lvdstatus = "LOW";
    timetracker = 0;
 }


if(lvdstatus == "LOW"){
    if(voltage < voltage_low){
      timetracker++;
      if(timetracker >= ChangeOverTime){
        //we have had the necessary time, so we can change state to OFF
        //turn off the output
        lvdstatus = "OFF";
        ledState = LOW;
        digitalWrite(mosfet, LOW);
      }
    }else{
      lvdstatus = "ON";
    }
 }
 
 if(lvdstatus == "OFF" and voltage > voltage_high){
    lvdstatus = "HIGH";
    timetracker = 0;
 }
 
 if(lvdstatus == "HIGH"){
   if(voltage > voltage_high){
     timetracker++;
     if(timetracker >= ChangeOverTime){
       //we have had the necessary time, so we can change state to ON
       //and turn on the output
       lvdstatus = "ON";
       ledState = HIGH;
       digitalWrite(mosfet, HIGH);
     }
   }else{
       lvdstatus = "OFF";
   }
 } 


// set the LED with the ledState of the variable:
    digitalWrite(ledPin, ledState);
// ---------- MANAGE THE OUTPUT END ------------

// ----------MAKE LED FLICKER FOR CHANGING STATE----------

 //if we are heading toward change of state, then flicker the backlight
  //either way - need to have a quarter second delay here for the benefit of screen readability
  //and also as we need a long time before changeover.
  if(lvdstatus == "LOW" or lvdstatus == "HIGH"){
    digitalWrite(ledPin, LOW);
    delay(125);
    digitalWrite(ledPin, HIGH);
    delay(125);
    digitalWrite(ledPin, LOW);
    delay(125);
    digitalWrite(ledPin, HIGH);
    delay(125);
  }
  else{
    delay(500);
}

// Void loop close
}


// ----------MAKE LED FLICKER FOR CHANGING STATE----------


